divert(-1)
#
# These rules use a map rather than a text file.  More efficient
# if the map is large and sendmail does not need to be restarted.
# 
# /etc/relay created from a file with one entry per line
# containing the domain name you relay to followed by OK
#
# domain.com OK
# 
# makemap hash /etc/relay < relay_text_file
# 
# /etc/local created from a file with one entry per line
# containing the domain name you allow relays from followed by OK
#
# localhost OK
# your.domain OK
# your.virtual.domain.one OK
# your.virtual.domain.two OK
# 
# makemap hash /etc/local < local_text_file
#
#
# /etc/allowed created from a file with one entry per line
# containing user@domain that you will relay for followed by OK
#
# makemap hash /etc/allowed < allowed_text_file
#
divert(0)
VERSIONID(`@(#)check_rcpt_1.m4 $Id:$')
PUSHDIVERT(6)
Krelay ifelse(_ARG_, `', `hash /etc/relay', `_ARG_')
Klocal ifelse(_ARG_, `', `hash /etc/local', `_ARG_')
Klocal_ip ifelse(_ARG_, `', `hash /etc/local_ip', `_ARG_')
Kallowed ifelse(_ARG_, `', `hash /etc/allowed', `_ARG_')
POPDIVERT

divert(2)
LOCAL_RULESETS

SStart
R$* $$| $*		$: $1 $| $2

Srelay

R$* $=w $* 		$@ <OK>			# Class w domains
R$*			$: $(relay $1$)		# lookup domain in database
ROK			$@ <OK>			# Return if entry exists
R$* $-.$-.$+		$: $>relay $3.$4	# Strip one level of domain and try again

Slocal

R$*			$: $(local $1$)		# lookup domain in database
R<OK>			$@ <OK>			# Return if entry exists
R$-.$-.$+		$: $>local $2.$3	# Strip one level of domain and try again

Slocal_ip

R$*			$: $(local_ip $1$)	# lookup domain in database
R<OK>			$@ <OK>			# Return if entry exists
R$+.$-.$-		$: $>local_ip $1.$2	# Strip lowest quad and try again

# Possible option would be to allow relay if the sender
# was using a from address where the domain matches the database.
# Anything with a from address of @allowed.domain could relay.
# Its a big hole though.
#
Sallowed

R$+<@$+>		$: $1<@$(allowed $1@$2 $:$2$)> 	# lookup address in database
R$+<@OK>		$@ <OK>				# Return if entry exists
R$+<@$-.$-.$+>		$: $>allowed $1<@$3.$4>		# Strip one level of domain and try again

# user%host@domain and user@host@domain is handled correctly.
# @relay.domain:user@host is not handled and will be rejected.
#
Sgood_relay

R$* < @ $+ >	$: $1 @ $>relay $2		# Look up domain in relay databse
R$* @ $+ . $*	$@ Not in relay database	# Just domain name left
R$* @ < OK >	$: $1				# Lookup succeeded
R$*		$: $>3 $1			# Canonify whats left
R$* < @ $* .>	$: $1 < @ $2 >			# Remove trailing . if there
R$* < @ $+ >	$: $>good_relay < @ $2 >	# Call this rule again
R < @ >		$@ < OK >			# Nothing left
R$-		$@ < OK >			# Just user name can remain


# from: $| to:
Scheck_rcpt

R$+ $| $+		$: $2 $| $>3 $1		# Canonify sender
R$+ $| $+		$: $2 $| $>3 $1		# Canonify recipient
R$+ $| $+		$: $2 $| $(dequote $1 $)# Clean up both
R$+ $| $+		$: $2 $| $(dequote $1 $)
R$+ $| $-		$@ ok			# To user name only

R$* $| $* < @ $- > $*	$#error $@ 5.1.8 $: 518 Invalid host name $3
R$* $| $* < @ $- . > $*	$#error $@ 5.1.8 $: 518 Invalid host name $3

R$*<@$*.> $| $*		$: $1<@$2> $| $3	# Remove trailing ., if there
R$+ $| $+		$: $2 $| $>allowed $1	# Check allowed relays from user@domain
						# Work space is now to: $| result of $>allowed
R$+ $| <OK>		$@ ok
R$+ $| $+		$: $1			# Get the to: address
R$*<@$*.>		$: $1<@$2>		# Remove trailing ., if there
R$*			$: $>good_relay $1	# See if we can relay to this domain
R<OK>			$@ ok

# Now look at the client and see if its allowed
#
# These rules use the client IP address if there are spoofing concerns
#
R$*			$: $(dequote "" $&{client_addr} $)
R0			$@ ok			# client_addr is 0 for sendmail -bs
R$*			$: $>local_ip $1	# Check the database
ROK			$@ ok
R$*			$#error $@ 4.7.1 $: "471 we do not relay"

# These rules use the client name
#
# R$*			$: $(dequote "" $&{client_addr} $)
# R0			$@ ok			# client_addr is 0 for sendmail -bs
# R$*			$: $(dequote "" $&{client_name} $)
# R$-			$@ ok			# Unqualified local names
# R$*			$: $>local $1		# Check the database
# ROK			$@ ok
# R$*			$#error $@ 4.7.1 $: "471 we do not relay"

divert(0)
